/////////////////////////////////////////////////////////////////////////////
//
// main.cpp - C/C++ zdrojov kd 
//
// (C) Radek Chalupa, 2002 - www.radekchalupa.cz
//
/////////////////////////////////////////////////////////////////////////////

#include "main.h"

#define _MainClassName TEXT("WinAPIMainClass")
#define _AppName TEXT("Ume se WinAPI")

HINSTANCE g_hInstance;
HWND g_hwndMain;

void centerText(HDC hdc)
{
	RECT rect;
	GetClientRect(g_hwndMain, &rect);
	SetBkMode(hdc, TRANSPARENT);
	DrawText(hdc, "Ji mme vlastn ikonu a kurzor!", -1, &rect,
		DT_SINGLELINE | DT_CENTER | DT_VCENTER);
}

void pozadiTextu(HDC hdc)
{
	TCHAR chText[100];
	lstrcpy(chText, TEXT("Modr barva psma..."));
	SetTextColor(hdc, 0x00FF0000); // modr text
	TextOut(hdc, 10, 10, chText, lstrlen(chText));

	SetBkColor(hdc, 0x0000FFFF); // lut pozad
	lstrcpy(chText, TEXT("Zmnme pozad, psmo zstv..."));
	TextOut(hdc, 10, 40, chText, lstrlen(chText));

	lstrcpy(chText, TEXT("Konen mme prhledn text !!!"));
	SetBkMode(hdc, TRANSPARENT); // prhlednost textu
	TextOut(hdc, 10, 70, chText, lstrlen(chText));

	lstrcpy(chText, TEXT("Pokraovn pt ..."));
	SetTextColor(hdc, 0x000000FF); // modr text
	TextOut(hdc, 10, 110, chText, lstrlen(chText));
}

void OnWM_PAINT()
{
	PAINTSTRUCT ps;
	HDC hdc;
	hdc = BeginPaint(g_hwndMain, &ps);
	centerText(hdc);
	DrawIcon(hdc, 10,10,
		(HICON)GetClassLongPtr(g_hwndMain, GCLP_HICON));
	EndPaint(g_hwndMain, &ps);
}

void VlastniKresleni(WPARAM wParam, LPARAM lParam)
{
	POINTS ptCursor;
	HDC hdc;
	TCHAR chText[30];
	ptCursor = MAKEPOINTS(lParam);
	_stprintf(chText, "x=%d, y=%d", ptCursor.x, ptCursor.y);
	hdc = GetDC(g_hwndMain);
	if ( wParam & MK_CONTROL )
		SetTextColor(hdc, 0x000000FF);
	TextOut(hdc, ptCursor.x, ptCursor.y, chText, lstrlen(chText));
	ReleaseDC(g_hwndMain, hdc);
}

void KresleniDoTitulku(WPARAM wParam, LPARAM lParam)
{
	POINTS ptCursor;
	HDC hdc;
	TCHAR chText[30];
	ptCursor = MAKEPOINTS(lParam);
	_stprintf(chText, "x=%d, y=%d", ptCursor.x, ptCursor.y);
	hdc = GetWindowDC(g_hwndMain);
	if ( wParam & MK_CONTROL )
		SetTextColor(hdc, 0x000000FF);
	TextOut(hdc, 150, 8, chText, lstrlen(chText));
	ReleaseDC(g_hwndMain, hdc);
}

void OnWM_MOUSEMOVE(WPARAM wParam, LPARAM lParam)
{
	POINTS ptCursor;
	TCHAR chText[30];
	ptCursor = MAKEPOINTS(lParam);
	_stprintf(chText, "x=%d, y=%d", ptCursor.x, ptCursor.y);
	SetWindowText(g_hwndMain, chText);
}

LRESULT CALLBACK WindowProcMain(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch ( message )
	{
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		case WM_MOUSEMOVE:
//			OnWM_MOUSEMOVE(wParam, lParam);
			break;
		case WM_LBUTTONDOWN:
//			KresleniDoTitulku(wParam, lParam);
			break;
		case WM_PAINT:
			OnWM_PAINT();
			break;
	}
	return DefWindowProc(hwnd, message, wParam, lParam);
}

TCHAR ch[20];

BOOL InitApp()
{
	WNDCLASSEX wc;
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1);
	wc.hCursor = LoadCursor(g_hInstance, MAKEINTRESOURCE(IDC_MAIN));
	wc.hIcon = LoadIcon(g_hInstance, MAKEINTRESOURCE(IDR_MAIN));
	wc.hIconSm = LoadIcon(g_hInstance, MAKEINTRESOURCE(IDR_MAIN));
	wc.hInstance = g_hInstance;
	wc.lpfnWndProc = WindowProcMain;
	wc.lpszClassName = _MainClassName;
	wc.lpszMenuName = NULL;
	wc.style = CS_HREDRAW | CS_VREDRAW;
	if ( !RegisterClassEx(&wc) )
		return FALSE;

	g_hwndMain = CreateWindowEx(0, _MainClassName,
		_AppName,
		WS_OVERLAPPEDWINDOW | WS_VISIBLE,
		100, 100, 350, 250,
		NULL, NULL, g_hInstance, NULL);
	if ( g_hwndMain == NULL )
		return FALSE;
	return TRUE;
}

MSG msg;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nShow)
{
	g_hInstance = hInstance;
	if ( !InitApp() )
		return FALSE;
	while ( GetMessage(&msg, NULL, 0, 0) )
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}
